# Generated by CMake

if("${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" LESS 2.6)
   message(FATAL_ERROR "CMake >= 2.6.0 required")
endif()
cmake_policy(PUSH)
cmake_policy(VERSION 2.6...3.20)
#----------------------------------------------------------------
# Generated CMake target import file.
#----------------------------------------------------------------

# Commands may need to know the format version.
set(CMAKE_IMPORT_FILE_VERSION 1)

# Protect against multiple inclusion, which would fail when already imported targets are added once more.
set(_targetsDefined)
set(_targetsNotDefined)
set(_expectedTargets)
foreach(_expectedTarget pinocchio::pinocchio_headers pinocchio::pinocchio_default pinocchio::pinocchio_visualizers pinocchio::pinocchio_parsers pinocchio::pinocchio_python_parser pinocchio::pinocchio pinocchio::pinocchio_pywrap_default)
  list(APPEND _expectedTargets ${_expectedTarget})
  if(NOT TARGET ${_expectedTarget})
    list(APPEND _targetsNotDefined ${_expectedTarget})
  endif()
  if(TARGET ${_expectedTarget})
    list(APPEND _targetsDefined ${_expectedTarget})
  endif()
endforeach()
if("${_targetsDefined}" STREQUAL "${_expectedTargets}")
  unset(_targetsDefined)
  unset(_targetsNotDefined)
  unset(_expectedTargets)
  set(CMAKE_IMPORT_FILE_VERSION)
  cmake_policy(POP)
  return()
endif()
if(NOT "${_targetsDefined}" STREQUAL "")
  message(FATAL_ERROR "Some (but not all) targets in this export set were already defined.\nTargets Defined: ${_targetsDefined}\nTargets not yet defined: ${_targetsNotDefined}\n")
endif()
unset(_targetsDefined)
unset(_targetsNotDefined)
unset(_expectedTargets)


# Compute the installation prefix relative to this file.
get_filename_component(_IMPORT_PREFIX "${CMAKE_CURRENT_LIST_FILE}" PATH)
get_filename_component(_IMPORT_PREFIX "${_IMPORT_PREFIX}" PATH)
get_filename_component(_IMPORT_PREFIX "${_IMPORT_PREFIX}" PATH)
get_filename_component(_IMPORT_PREFIX "${_IMPORT_PREFIX}" PATH)
get_filename_component(_IMPORT_PREFIX "${_IMPORT_PREFIX}" PATH)
if(_IMPORT_PREFIX STREQUAL "/")
  set(_IMPORT_PREFIX "")
endif()

# Create imported target pinocchio::pinocchio_headers
add_library(pinocchio::pinocchio_headers INTERFACE IMPORTED)

set_target_properties(pinocchio::pinocchio_headers PROPERTIES
  INTERFACE_COMPILE_DEFINITIONS "BOOST_MPL_LIMIT_LIST_SIZE=30;BOOST_MPL_LIMIT_VECTOR_SIZE=30"
  INTERFACE_INCLUDE_DIRECTORIES "${_IMPORT_PREFIX}/include"
  INTERFACE_LINK_LIBRARIES "Eigen3::Eigen;Boost::boost;Boost::serialization"
)

# Create imported target pinocchio::pinocchio_default
add_library(pinocchio::pinocchio_default SHARED IMPORTED)

set_target_properties(pinocchio::pinocchio_default PROPERTIES
  INTERFACE_COMPILE_DEFINITIONS "PINOCCHIO_ENABLE_TEMPLATE_INSTANTIATION"
  INTERFACE_INCLUDE_DIRECTORIES "${_IMPORT_PREFIX}/include"
  INTERFACE_LINK_LIBRARIES "pinocchio::pinocchio_headers"
)

# Create imported target pinocchio::pinocchio_visualizers
add_library(pinocchio::pinocchio_visualizers SHARED IMPORTED)

set_target_properties(pinocchio::pinocchio_visualizers PROPERTIES
  INTERFACE_COMPILE_DEFINITIONS "PINOCCHIO_ENABLE_TEMPLATE_INSTANTIATION"
  INTERFACE_INCLUDE_DIRECTORIES "${_IMPORT_PREFIX}/include"
  INTERFACE_LINK_LIBRARIES "pinocchio::pinocchio_headers;pinocchio::pinocchio_default"
)

# Create imported target pinocchio::pinocchio_parsers
add_library(pinocchio::pinocchio_parsers SHARED IMPORTED)

set_target_properties(pinocchio::pinocchio_parsers PROPERTIES
  INTERFACE_COMPILE_DEFINITIONS "PINOCCHIO_ENABLE_TEMPLATE_INSTANTIATION;PINOCCHIO_WITH_URDFDOM"
  INTERFACE_INCLUDE_DIRECTORIES "${_IMPORT_PREFIX}/include;/usr/lib/aarch64-linux-gnu/urdfdom/cmake/../../../../include;/usr/include;/usr/include;/usr/include"
  INTERFACE_LINK_LIBRARIES "pinocchio::pinocchio_headers;pinocchio::pinocchio_default;Boost::filesystem;/usr/lib/aarch64-linux-gnu/liburdfdom_sensor.so;/usr/lib/aarch64-linux-gnu/liburdfdom_model_state.so;/usr/lib/aarch64-linux-gnu/liburdfdom_model.so;/usr/lib/aarch64-linux-gnu/liburdfdom_world.so;console_bridge::console_bridge"
  INTERFACE_SYSTEM_INCLUDE_DIRECTORIES "/usr/lib/aarch64-linux-gnu/urdfdom/cmake/../../../../include;/usr/include;/usr/include;/usr/include"
)

# Create imported target pinocchio::pinocchio_python_parser
add_library(pinocchio::pinocchio_python_parser SHARED IMPORTED)

set_target_properties(pinocchio::pinocchio_python_parser PROPERTIES
  INTERFACE_COMPILE_DEFINITIONS "PINOCCHIO_ENABLE_TEMPLATE_INSTANTIATION"
  INTERFACE_INCLUDE_DIRECTORIES "${_IMPORT_PREFIX}/include"
  INTERFACE_LINK_LIBRARIES "pinocchio::pinocchio_headers;pinocchio::pinocchio_default;Python3::Python;Boost::python310"
)

# Create imported target pinocchio::pinocchio
add_library(pinocchio::pinocchio INTERFACE IMPORTED)

set_target_properties(pinocchio::pinocchio PROPERTIES
  INTERFACE_LINK_LIBRARIES "pinocchio::pinocchio_default;pinocchio::pinocchio_parsers;pinocchio::pinocchio_visualizers"
)

# Create imported target pinocchio::pinocchio_pywrap_default
add_library(pinocchio::pinocchio_pywrap_default SHARED IMPORTED)

set_target_properties(pinocchio::pinocchio_pywrap_default PROPERTIES
  INTERFACE_LINK_LIBRARIES "eigenpy::eigenpy;pinocchio::pinocchio;console_bridge::console_bridge"
)

if(CMAKE_VERSION VERSION_LESS 3.0.0)
  message(FATAL_ERROR "This file relies on consumers using CMake 3.0.0 or greater.")
endif()

# Load information for each installed configuration.
get_filename_component(_DIR "${CMAKE_CURRENT_LIST_FILE}" PATH)
file(GLOB CONFIG_FILES "${_DIR}/pinocchioTargets-*.cmake")
foreach(f ${CONFIG_FILES})
  include(${f})
endforeach()

# Cleanup temporary variables.
set(_IMPORT_PREFIX)

# Loop over all imported files and verify that they actually exist
foreach(target ${_IMPORT_CHECK_TARGETS} )
  foreach(file ${_IMPORT_CHECK_FILES_FOR_${target}} )
    if(NOT EXISTS "${file}" )
      message(FATAL_ERROR "The imported target \"${target}\" references the file
   \"${file}\"
but this file does not exist.  Possible reasons include:
* The file was deleted, renamed, or moved to another location.
* An install or uninstall procedure did not complete successfully.
* The installation package was faulty and contained
   \"${CMAKE_CURRENT_LIST_FILE}\"
but not all the files it references.
")
    endif()
  endforeach()
  unset(_IMPORT_CHECK_FILES_FOR_${target})
endforeach()
unset(_IMPORT_CHECK_TARGETS)

# This file does not depend on other imported targets which have
# been exported from the same project but in a separate export set.

# Commands beyond this point should not need to know the version.
set(CMAKE_IMPORT_FILE_VERSION)
cmake_policy(POP)
